namespace DbContextWrapperExample.Entities
{
    using System;
    using System.Data.Entity;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Linq;

    public partial class Jiggy : DbContext
    {
        public Jiggy() : base("name=Jiggy") { }

        public virtual DbSet<Stuff> Stuffs { get; set; }
        public virtual DbSet<Thing> Things { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Stuff>()
                .Property(e => e.Name)
                .IsUnicode(false);

            modelBuilder.Entity<Stuff>()
                .HasMany(e => e.Things)
                .WithRequired(e => e.Stuff)
                .WillCascadeOnDelete(false);

            modelBuilder.Entity<Thing>()
                .Property(e => e.Name)
                .IsUnicode(false);

            modelBuilder.Entity<Thing>()
                .Property(e => e.Description)
                .IsUnicode(false);
        }
    }
}
