﻿namespace DbContextWrapperExample
{
    using System.Collections.Generic;
    using System.Data.Entity;
    using System.Linq;
    using Entities;
    using Tynamix.ObjectFiller;

    class Program
    {
        static void Main(string[] args)
        {
            var dbWrap = new DbContextWrapper<Jiggy>();

            var stuffFiller = new Filler<Stuff>();
            var stuffs = new List<Stuff>();
            for (var i = 0; i < 50; i++)
            {
                var stuff = stuffFiller.Create();
                stuff.Name = stuff.Name.Substring(0, 20);//because the object filler makes too big of a string.
                stuff.Things = null;

                stuffs.Add(stuff);
                dbWrap.Call(context =>
                {
                    context.Stuffs.Add(stuff);
                    context.SaveChanges();
                });
            }

            var thingFiler = new Filler<Thing>();
            for (var i = 0; i < 50; i++)
            {
                var thing = thingFiler.Create();
                thing.Name = thing.Name.Substring(0, 20);//because the object filler makes too big of a string.
                thing.Description = thing.Description.Substring(0, 50);//because the object filler makes too big of a string.
                thing.Stuff = null;
                thing.StuffGuid = stuffs[i].StuffGuid;

                dbWrap.Call(context =>
                {
                    context.Things.Add(thing);
                    context.SaveChanges();
                });
            }

            var stuffGuid = stuffs[2].StuffGuid;

            var oneOfTheStuffs = dbWrap.Call(context => context.Stuffs.Where(s => s.StuffGuid == stuffGuid).Include(i => i.Things).SingleOrDefault());

            var someOfTheThings = dbWrap.Call(context => context.Things.Where(t => t.StuffGuid == stuffGuid).ToList());
        }
    }
}